\ ATMEL 45DB041B dataflash command
\ using the SPI of ATmega169

\ include "dataflash_rw.asm" ( dfinit, spirw) 


\ commands have ( #page #byte -- ) on stack, no result.
\ exeption: status register read has no input.


hex

: cstoggle ( -- )   \ pulse CS line, then keep it low.
  1 25 c! 1ms 0 25 c! ;

: dfadr  ( #page #bytes -- adrH adrL )
  over 9 lshift +        \ LO cell
  swap 7 rshift swap ;   \ HI cell

: dfcom ( adrH adrL op -- ) 
  cstoggle
  spirw drop           \ send opcode
  dfadr                \ pack addresses into 24 bits
  swap spirw drop      \ send adrH LO byte, HI byte = dont care
  dup >< spirw drop    \ send adrL HI byte
  spirw drop ;         \ send adrL LO byte
    
: (32x) ( -- )  \ send 32 dont care bits
  0 spirw spirw spirw spirw drop ;

: (8x) ( -- )   \ send 8 dont care bits
  0 spirw drop ;

: () ( -- ) ;  \ send no dont care bits

\ finis
